/******************************************************
 * dqHȑO̐@v
 *@PIC16F1709@@RTC8564gp
 *@xZT@@S8100B
 ******************************************************/
#include <xc.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"
/* RtBM[V̐ݒ */
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection Bits (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover Mode (Internal/External Switchover Mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PPS1WAY = OFF    // Peripheral Pin Select one-way control (The PPSLOCK bit can be set and cleared repeatedly by software)
#pragma config ZCDDIS = ON      // Zero-cross detect disable (Zero-cross detect circuit is disabled at POR)
#pragma config PLLEN = OFF      // Phase Lock Loop enable (4x PLL is enabled when software sets the SPLLEN bit)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LPBOR = OFF      // Low-Power Brown Out Reset (Low-Power BOR is disabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)
/** O[oϐ萔` ***/
unsigned char StMsg[] = "**Start Clock** ";
unsigned char Mesg[] = " mm/dd hh:mm:ss ";
unsigned char TMsg[] = " Ondo xx.x 'C   ";
unsigned char SetMsg[] = "Setting  Y = xx ";

unsigned char Buffer[8];
unsigned char Year, Month, Day, Hour, Min, Sec, Week;
unsigned char Select, SW, Cflag, Flag;
int temp;
float Ondo;

/* ֐vg^Cv */
unsigned char CheckKey(void);
int Mesure(unsigned char ch);
void CurDisp(void);
void Settings(void);
unsigned char BCD(unsigned char data);
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);

/************** C֐  *************************/
int main(void) {
    /* NbNݒ */
    OSCCONbits.IRCF = 13;               // 4MHz
    /* I/Oݒ*/
    LATA = 0;                           // LED Off
    LATC = 0;                           // LED Off
    ANSELA = 0;                         // ׂăfW^
    ANSELB = 0;
    ANSELC = 0xC8;                      // RC3,6,7AiO
    TRISA = 0x2F;
    TRISB = 0x50;
    TRISC = 0xCF;                       // XCb`
    WPUC = 0x07;                        // XCb`@RC0,1,2vAbv
    WPUAbits.WPUA2 = 1;                 // XCb`@RA2̂݃vAbv
    OPTION_REGbits.nWPUEN = 0;          // vAbvL
    /* IyAv2ݒ */
    OPA2CON = 0x90;                     // Unity Gain
    FVRCON = 0x82;                      // FVR1 = 2.048V FVR2 = Off
    /* A/DRo[^ݒ */
    ADCON1 = 0x93;                      // El߁AFosc/8AVref=FVR1
    ADCON2 = 0;                         // }jAϊ
    /** I2C **/
    RB4PPS = 0x11;                      // SDA1st
    RB6PPS = 0x10;                      // SCL1st
    SSP1ADD = 0x4F;                     // 100kHzȉ
    SSP1CON1 = 0x38;                    // I2CCl[u
    SSP1STAT = 0;                       // ԃNA
    /* t\평 */
    LATBbits.LATB5 = 1;                 // LCDdI
    lcd_init();                         // LCD
    lcd_clear();                        // S
    lcd_str(StMsg);                     // JnbZ[W\
    /* RTCݒ */
    CmdI2C(0xA2, 0x00, 0x20);           // Stop
    CmdI2C(0xA2, 0x0D, 0x83);           // bpXo͐ݒ
    CmdI2C(0xA2, 0x00, 0x00);           //Start
    /* ԕω荞ݐݒiRA@b荞݁j */
    IOCAPbits.IOCAP5 = 1;               // GbWL
    IOCAFbits.IOCAF5 = 0;               // tONA
    INTCONbits.IOCIF = 0;               // tONA
    INTCONbits.IOCIE = 1;               // ԕω荞݋
    INTCONbits.PEIE = 1;                // ӊ荞݋
    INTCONbits.GIE = 1;                 // 荞݋
    /** ϐ@**/
    Cflag = 0;                          // ݒ蒆tOZbg
    
    /************ C[v@@*****************/
    while(1)
    {
        /** \ ***/
        if(Flag == 1){                          // 荞݂̏ꍇ
            Flag = 0;                           // btONA
            SendI2C(0xA2, 0x02);                // WX^|C^[Zbg
            GetDataI2C(0xA2, Buffer, 7);        // 7byte Read@Nb܂
            Year = ((Buffer[6]&0xF0) >> 4)*10;  // NBCDoCi
            Year += Buffer[6] & 0x0F;
            Month = ((Buffer[5]&0x10) >> 4)*10; // BCDoCi
            Month += Buffer[5] & 0x0F;
            itostring(2, Month, Mesg+1);        // 𕶎ɕϊ
            Day = ((Buffer[3]&0x30)>>4)*10;     // BCDoCi
            Day += Buffer[3]&0x0F;
            itostring(2, Day, Mesg+4);          // 𕶎ɕϊ
            Hour = ((Buffer[2]&0x30) >> 4)*10;  // ԂBCDoCi
            Hour+= Buffer[2] & 0x0F;
            itostring(2, Hour, Mesg+7);         // Ԃ𕶎ɕϊ
            Min = ((Buffer[1]&0x70) >> 4)*10;   // BCDoCi
            Min += Buffer[1] & 0x0F;
            itostring(2, Min, Mesg+10);         // 𕶎ɕϊ
            Sec = ((Buffer[0]&0x70) >> 4) * 10; // bBCDoCi
            Sec += Buffer[0] & 0x0F;
            itostring(2, Sec, Mesg+13);         // b𕶎ɕϊ
            Mesg[15] = ' ';                     // Xy[X
            lcd_cmd(0x80);                      // 1sڎw
            lcd_str(Mesg);                      // b\
            /**** xv\@10b *****/
            if((Sec%10) == 0){                      // 10b
                temp = Mesure(7);                   // A/Dv
                Ondo = (2.048 * temp) / 1024;       // dɕϊ
                Ondo = -123.0 * Ondo + 214.7;       // xɕϊ
                ftostring(2, 1, Ondo, TMsg+6);      // ɕϊ
                TMsg[11] = 0xDF;                    // ̕
                lcd_cmd(0xC0);                      // 2sڎw
                lcd_str(TMsg);                      // x\
            }
           /******** XCb`̓̓`FbN ********/
            SW = CheckKey();                        // XCb`
            if(SW == 1){                            // SW1H
                Cflag = 1;                          // XVtOI
                Settings();                         // ݒ菈
            }
        }
        /******* X[v[hɓ *********/
        SLEEP();
    }
}
/*************************************
 *@ԕω荞ݏ֐
 ************************************/
void interrupt IOCPROC(void){
    Flag = 1;                       // tOZbg
//    LATAbits.LATA4 ^= 1;            // ڈ_
    INTCONbits.IOCIF = 0;           // 荞݃tONA
    IOCAFbits.IOCAF5 = 0;           // 荞݃tONA
}
/********************************************
 * A/DϊTu֐
 *******************************************/
int Mesure(unsigned char ch){
    int value;
    
    ADCON0 = (ch <<2) | 0x01;       // ADC On Select Channel
    Delayus(100);                   // 艻҂
    ADCON0bits.GO = 1;              // Start
    while(ADCON0bits.GO);           // ANCWV^C
    value = ADRESH*256+ADRESL;      // 10rbgoCi֕ϊ
    ADCON0 = 0;                     // ADC Off
    return(value);                  // lԂ
}
/****************************************
*  XCb`̓Tu֐
*  ߂lɃXCb`ԍ
***************************************/
unsigned char CheckKey(void){
    unsigned char Key;

    Key = 0;                        // lNA
    if(PORTCbits.RC2 == 0)          // SelectXCb`
        Key = 1;                    // 1Ԃ
    if(PORTCbits.RC1 == 0)          // UpXCb`
        Key = 2;                    // 2Ԃ
    if(PORTCbits.RC0 == 0)          // DownXCb`
        Key = 3;                    // 3Ԃ
    if(PORTAbits.RA2 == 0)          // EnterXCb`
        Key = 4;                    // 4Ԃ
    return(Key);
}
/********************************************
*  ݒl\Tu֐iݒ蒆̕\ )
********************************************/
void CurDisp(void){
    SetMsg[15] = ' ';
    switch(Select){
        case 0:                             // N̏ꍇ
            SetMsg[9] = 'Y';
            itostring(2, Year, SetMsg+13);  // ݒl𕶎ɕϊ
            break;
        case 1:                             // ̏ꍇ
            SetMsg[9] = 'M';
            itostring(2, Month, SetMsg+13); // ݒl𕶎ɕϊ
            break;
        case 2:                             // ̏ꍇ
            SetMsg[9] = 'D';
            itostring(2, Day, SetMsg+13);   // ݒl𕶎ɕϊ
            break;;
        case 3:                             // ̏ꍇ
            SetMsg[9] = 'H';
            itostring(2, Hour, SetMsg+13);  // ݒl𕶎ɕϊ
            break;
        case 4:                             // ̏ꍇ
            SetMsg[9] = 'm';
            itostring(2, Min, SetMsg+13);   // ݒl𕶎ɕϊ
            break;
        case 5:                             // b̏ꍇ
            SetMsg[9] = 'S';
            itostring(2, Sec, SetMsg+13);   // ݒl𕶎ɕϊ
            break;
        default:
            break;
    }
    lcd_cmd(0x80);                          // 1sڎw
    lcd_str(SetMsg);                        // ݒl\
}
/*******************************************
* ݒ菈
*@KeyFSelectAUpADownASet
*******************************************/
void Settings(void){
    Select = 0;                             // Nɏݒ
    CurDisp();                              // ݒl\
    while(CheckKey() != 0);                 // `b^
    Delayms(25);
    /*** ݒ蒆̃[v  ****/
    while(Cflag){                           // XVtOȈꍇ[v
        SW = CheckKey();                    // XCb`
        while(CheckKey() != 0);             // `b^
        Delayms(25);
        /* XCb`Ƃ̃vZX */
        switch(SW){                         // SW̒lŕ
            case 1:
                Select++;                   // IڍXV
                if(Select > 5)              // `FbN
                    Select = 0;             // ŏɖ߂
                CurDisp();                  // ݒl\
                break;
            case 2:
                switch(Select){             // Abv
                    case 0:
                        Year++;             // NAbv
                        if(Year > 99)       // ől99
                            Year = 0;       // 0ɖ߂
                        break;
                    case 1:
                        Month++;            // Abv
                        if(Month > 12)      // 12ő
                            Month = 1;      // 1ɖ߂
                        break;
                    case 2:                 // Abv
                        Day++;
                        if(Day > 31)        // 召Ȃ
                            Day = 1;        // 1ɖ߂
                        break;
                    case 3:
                        Hour++;             // ԃAbv
                        if(Hour > 23)       // 23ő
                            Hour = 0;       // 0ɖ߂
                        break;
                    case 4:
                        Min++;              // Abv
                        if(Min > 59)        // 59ő
                            Min = 0;        // 0ɖ߂
                        break;
                    case 5:
                        Sec++;              // bAbv
                        if(Sec > 59)        // 59bő
                            Sec = 0;        // 0bɖ߂
                        break;
                    default: break;
                }
                CurDisp();                  // XVl\
                break;
            case 3:
                switch(Select){             // _E
                    case 0:
                        if(Year > 0)        // N_E
                            Year--;
                        break;
                    case 1:
                        Month--;            // _E
                        if(Month < 1)
                            Month = 12;
                        break;
                    case 2:
                        Day--;              // _E
                        if(Day < 1)
                            Day = 31;
                        break;
                    case 3:
                        if(Hour > 0)        // ԃ_E
                            Hour--;
                        else
                            Hour = 23;
                        break;
                    case 4:
                        if(Min > 0)         // _E
                            Min--;
                        else
                            Min = 59;
                        break;
                    case 5:
                        if(Sec > 0)         // b_E
                            Sec--;
                        else
                            Sec = 59;
                        break;
                    default: break;
                }
                CurDisp();                  // XVl\
                break;
            case 4:                                 // ݒ芮
                /** XV **/
                lcd_clear();
                CmdI2C(0xA2, 0x00, 0x20);           // ~
                CmdI2C(0xA2, 0x02, BCD(Sec));       // bݒ
                CmdI2C(0xA2, 0x03, BCD(Min));       // ݒ
                CmdI2C(0xA2, 0x04, BCD(Hour));      // ݒ
                CmdI2C(0xA2, 0x05, BCD(Day));       // ݒ
                CmdI2C(0xA2, 0x06, 0);              // jݒ
                CmdI2C(0xA2, 0x07, BCD(Month));     // ݒ
                CmdI2C(0xA2, 0x08, BCD(Year));      // Nݒ
                CmdI2C(0xA2, 0x00, 0x00);           // ăX^[g
                Cflag = 0;                          // XVtOIt
                break;
            default: break;
        }
    }
}
/**** oCiBCDւ̕ϊ *****/
unsigned char BCD(unsigned char data)
{
    unsigned char flow;
    flow = 0;
    flow = (data / 10) << 4;        // ʌ
    flow += (data % 10);            // ʌ
    return(flow);
}
/***************************************
* intASCIIɕϊ
****************************************/
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                            // Ō̐ʒu
    for(i=digit; i>0; i--) {                    // ϊ͉ʂʂ
        buffer--;                               // |C^[P
        *buffer = (data % 10) + '0';            // ASCII
        data = data / 10;                       // ̌
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--)	{           //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
    i = 0;                                  // uLO
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){   // ʌ0̊
        *buffer = ' ';                      // uNɕϊ
        buffer++;
        i++;
    }
}

